Gentoo Archives: gentoo-commits

From: "Mike Gilbert (floppym)" <floppym@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] gentoo-x86 commit in sys-apps/systemd: systemd-212-r5.ebuild ChangeLog systemd-212-r4.ebuild
Date: Fri, 30 May 2014 02:29:20
Message-Id: 20140530022914.3F33A2004F@flycatcher.gentoo.org
1 floppym 14/05/30 02:29:14
2
3 Modified: ChangeLog
4 Added: systemd-212-r5.ebuild
5 Removed: systemd-212-r4.ebuild
6 Log:
7 Add compatibility symlinks to prevent build failures do to broken usage of libsystemd-*.
8
9 (Portage version: 2.2.10/cvs/Linux x86_64, signed Manifest commit with key 0BBEEA1FEA4843A4)
10
11 Revision Changes Path
12 1.258 sys-apps/systemd/ChangeLog
13
14 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/sys-apps/systemd/ChangeLog?rev=1.258&view=markup
15 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/sys-apps/systemd/ChangeLog?rev=1.258&content-type=text/plain
16 diff : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/sys-apps/systemd/ChangeLog?r1=1.257&r2=1.258
17
18 Index: ChangeLog
19 ===================================================================
20 RCS file: /var/cvsroot/gentoo-x86/sys-apps/systemd/ChangeLog,v
21 retrieving revision 1.257
22 retrieving revision 1.258
23 diff -u -r1.257 -r1.258
24 --- ChangeLog 29 May 2014 13:34:34 -0000 1.257
25 +++ ChangeLog 30 May 2014 02:29:14 -0000 1.258
26 @@ -1,6 +1,13 @@
27 # ChangeLog for sys-apps/systemd
28 # Copyright 1999-2014 Gentoo Foundation; Distributed under the GPL v2
29 -# $Header: /var/cvsroot/gentoo-x86/sys-apps/systemd/ChangeLog,v 1.257 2014/05/29 13:34:34 mgorny Exp $
30 +# $Header: /var/cvsroot/gentoo-x86/sys-apps/systemd/ChangeLog,v 1.258 2014/05/30 02:29:14 floppym Exp $
31 +
32 +*systemd-212-r5 (30 May 2014)
33 +
34 + 30 May 2014; Mike Gilbert <floppym@g.o> +systemd-212-r5.ebuild,
35 + -systemd-212-r4.ebuild:
36 + Add compatibility symlinks to prevent build failures do to broken usage of
37 + libsystemd-*.
38
39 *systemd-213 (29 May 2014)
40
41
42
43
44 1.1 sys-apps/systemd/systemd-212-r5.ebuild
45
46 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/sys-apps/systemd/systemd-212-r5.ebuild?rev=1.1&view=markup
47 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/sys-apps/systemd/systemd-212-r5.ebuild?rev=1.1&content-type=text/plain
48
49 Index: systemd-212-r5.ebuild
50 ===================================================================
51 # Copyright 1999-2014 Gentoo Foundation
52 # Distributed under the terms of the GNU General Public License v2
53 # $Header: /var/cvsroot/gentoo-x86/sys-apps/systemd/systemd-212-r5.ebuild,v 1.1 2014/05/30 02:29:14 floppym Exp $
54
55 EAPI=5
56
57 AUTOTOOLS_PRUNE_LIBTOOL_FILES=all
58 PYTHON_COMPAT=( python{2_7,3_2,3_3} )
59 inherit autotools-utils bash-completion-r1 fcaps linux-info multilib \
60 multilib-minimal pam python-single-r1 systemd toolchain-funcs udev \
61 user
62
63 DESCRIPTION="System and service manager for Linux"
64 HOMEPAGE="http://www.freedesktop.org/wiki/Software/systemd"
65 SRC_URI="http://www.freedesktop.org/software/systemd/${P}.tar.xz"
66
67 LICENSE="GPL-2 LGPL-2.1 MIT public-domain"
68 SLOT="0/2"
69 KEYWORDS="~alpha ~amd64 ~arm ~ia64 ~ppc ~ppc64 ~sparc ~x86"
70 IUSE="acl audit cryptsetup doc +firmware-loader gcrypt gudev http introspection
71 kdbus +kmod lzma pam policykit python qrcode +seccomp selinux ssl
72 test vanilla xattr"
73
74 # http://lists.freedesktop.org/archives/systemd-devel/2014-March/018267.html
75 # (fixed in git)
76 MINKV="3.7"
77
78 COMMON_DEPEND=">=sys-apps/util-linux-2.20:0=
79 sys-libs/libcap:0=
80 acl? ( sys-apps/acl:0= )
81 audit? ( >=sys-process/audit-2:0= )
82 cryptsetup? ( >=sys-fs/cryptsetup-1.6:0= )
83 gcrypt? ( >=dev-libs/libgcrypt-1.4.5:0= )
84 gudev? ( dev-libs/glib:2=[${MULTILIB_USEDEP}] )
85 http? (
86 >=net-libs/libmicrohttpd-0.9.33:0=
87 ssl? ( >=net-libs/gnutls-3.1.4:0= )
88 )
89 introspection? ( >=dev-libs/gobject-introspection-1.31.1:0= )
90 kmod? ( >=sys-apps/kmod-15:0= )
91 lzma? ( app-arch/xz-utils:0=[${MULTILIB_USEDEP}] )
92 pam? ( virtual/pam:= )
93 python? ( ${PYTHON_DEPS} )
94 qrcode? ( media-gfx/qrencode:0= )
95 seccomp? ( sys-libs/libseccomp:0= )
96 selinux? ( sys-libs/libselinux:0= )
97 xattr? ( sys-apps/attr:0= )
98 abi_x86_32? ( !<=app-emulation/emul-linux-x86-baselibs-20130224-r9
99 !app-emulation/emul-linux-x86-baselibs[-abi_x86_32(-)] )"
100
101 # baselayout-2.2 has /run
102 RDEPEND="${COMMON_DEPEND}
103 >=sys-apps/baselayout-2.2
104 || (
105 >=sys-apps/util-linux-2.22
106 <sys-apps/sysvinit-2.88-r4
107 )
108 !sys-auth/nss-myhostname
109 !<sys-libs/glibc-2.14
110 !sys-fs/udev"
111
112 # sys-apps/daemon: the daemon only (+ build-time lib dep for tests)
113 PDEPEND=">=sys-apps/dbus-1.6.8-r1:0
114 >=sys-apps/hwids-20130717-r1[udev]
115 >=sys-fs/udev-init-scripts-25
116 policykit? ( sys-auth/polkit )
117 !vanilla? ( sys-apps/gentoo-systemd-integration )"
118
119 # Newer linux-headers needed by ia64, bug #480218
120 DEPEND="${COMMON_DEPEND}
121 app-arch/xz-utils:0
122 dev-util/gperf
123 >=dev-util/intltool-0.50
124 >=sys-devel/binutils-2.23.1
125 >=sys-devel/gcc-4.6
126 >=sys-kernel/linux-headers-${MINKV}
127 ia64? ( >=sys-kernel/linux-headers-3.9 )
128 virtual/pkgconfig
129 doc? ( >=dev-util/gtk-doc-1.18 )
130 python? ( dev-python/lxml[${PYTHON_USEDEP}] )
131 test? ( >=sys-apps/dbus-1.6.8-r1:0 )"
132
133 src_prepare() {
134 local PATCHES=(
135 "${FILESDIR}"/212-0001-sd-rtnl-fix-off-by-one.patch
136 "${FILESDIR}"/212-0002-fsck-Search-for-fsck.type-in-PATH.patch
137 )
138
139 # Bug 463376
140 sed -i -e 's/GROUP="dialout"/GROUP="uucp"/' rules/*.rules || die
141
142 autotools-utils_src_prepare
143 }
144
145 pkg_pretend() {
146 local CONFIG_CHECK="~AUTOFS4_FS ~BLK_DEV_BSG ~CGROUPS ~DEVTMPFS ~DMIID
147 ~EPOLL ~FANOTIFY ~FHANDLE ~INOTIFY_USER ~IPV6 ~NET ~NET_NS ~PROC_FS
148 ~SECCOMP ~SIGNALFD ~SYSFS ~TIMERFD
149 ~!IDE ~!SYSFS_DEPRECATED ~!SYSFS_DEPRECATED_V2
150 ~!GRKERNSEC_PROC"
151
152 use acl && CONFIG_CHECK+=" ~TMPFS_POSIX_ACL"
153 use pam && CONFIG_CHECK+=" ~AUDITSYSCALL"
154 use xattr && CONFIG_CHECK+=" ~TMPFS_XATTR"
155 kernel_is -lt 3 7 && CONFIG_CHECK+=" ~HOTPLUG"
156 use firmware-loader || CONFIG_CHECK+=" ~!FW_LOADER_USER_HELPER"
157
158 if linux_config_exists; then
159 local uevent_helper_path=$(linux_chkconfig_string UEVENT_HELPER_PATH)
160 if [ -n "${uevent_helper_path}" ] && [ "${uevent_helper_path}" != '""' ]; then
161 ewarn "It's recommended to set an empty value to the following kernel config option:"
162 ewarn "CONFIG_UEVENT_HELPER_PATH=${uevent_helper_path}"
163 fi
164 fi
165
166 if [[ ${MERGE_TYPE} != binary ]]; then
167 if [[ $(gcc-major-version) -lt 4
168 || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 6 ) ]]
169 then
170 eerror "systemd requires at least gcc 4.6 to build. Please switch the active"
171 eerror "gcc version using gcc-config."
172 die "systemd requires at least gcc 4.6"
173 fi
174 fi
175
176 if [[ ${MERGE_TYPE} != buildonly ]]; then
177 if kernel_is -lt ${MINKV//./ }; then
178 ewarn "Kernel version at least ${MINKV} required"
179 fi
180
181 if ! use firmware-loader && kernel_is -lt 3 8; then
182 ewarn "You seem to be using kernel older than 3.8. Those kernel versions"
183 ewarn "require systemd with USE=firmware-loader to support loading"
184 ewarn "firmware. Missing this flag may cause some hardware not to work."
185 fi
186
187 check_extra_config
188 fi
189 }
190
191 pkg_setup() {
192 use python && python-single-r1_pkg_setup
193 }
194
195 src_configure() {
196 # Keep using the one where the rules were installed.
197 MY_UDEVDIR=$(get_udevdir)
198 # Fix systems broken by bug #509454.
199 [[ ${MY_UDEVDIR} ]] || MY_UDEVDIR=/lib/udev
200
201 multilib-minimal_src_configure
202 }
203
204 multilib_src_configure() {
205 local myeconfargs=(
206 # disable -flto since it is an optimization flag
207 # and makes distcc less effective
208 cc_cv_CFLAGS__flto=no
209
210 --disable-maintainer-mode
211 --localstatedir=/var
212 --with-pamlibdir=$(getpam_mod_dir)
213 # avoid bash-completion dep
214 --with-bashcompletiondir="$(get_bashcompdir)"
215 # make sure we get /bin:/sbin in $PATH
216 --enable-split-usr
217 # disable sysv compatibility
218 --with-sysvinit-path=
219 --with-sysvrcnd-path=
220 # no deps
221 --enable-efi
222 --enable-ima
223 # optional components/dependencies
224 $(use_enable acl)
225 $(use_enable audit)
226 $(use_enable cryptsetup libcryptsetup)
227 $(use_enable doc gtk-doc)
228 $(use_enable gcrypt)
229 $(use_enable gudev)
230 $(use_enable http microhttpd)
231 $(usex http $(use_enable ssl gnutls) --disable-gnutls)
232 $(use_enable introspection)
233 $(use_enable kdbus)
234 $(use_enable kmod)
235 $(use_enable lzma xz)
236 $(use_enable pam)
237 $(use_enable policykit polkit)
238 $(use_with python)
239 $(use_enable python python-devel)
240 $(use_enable qrcode qrencode)
241 $(use_enable seccomp)
242 $(use_enable selinux)
243 $(use_enable test tests)
244 $(use_enable xattr)
245
246 # not supported (avoid automagic deps in the future)
247 --disable-chkconfig
248
249 # hardcode a few paths to spare some deps
250 QUOTAON=/usr/sbin/quotaon
251 QUOTACHECK=/usr/sbin/quotacheck
252
253 # dbus paths
254 --with-dbuspolicydir="${EPREFIX}/etc/dbus-1/system.d"
255 --with-dbussessionservicedir="${EPREFIX}/usr/share/dbus-1/services"
256 --with-dbussystemservicedir="${EPREFIX}/usr/share/dbus-1/system-services"
257 --with-dbusinterfacedir="${EPREFIX}/usr/share/dbus-1/interfaces"
258 )
259
260 if use firmware-loader; then
261 myeconfargs+=(
262 --with-firmware-path="/lib/firmware/updates:/lib/firmware"
263 )
264 fi
265
266 # Added for testing; this is UNSUPPORTED by the Gentoo systemd team!
267 if [[ -n ${ROOTPREFIX+set} ]]; then
268 myeconfargs+=(
269 --with-rootprefix="${ROOTPREFIX}"
270 --with-rootlibdir="${ROOTPREFIX}/$(get_libdir)"
271 )
272 fi
273
274 if ! multilib_is_native_abi; then
275 myeconfargs+=(
276 ac_cv_search_cap_init=
277 ac_cv_header_sys_capability_h=yes
278 DBUS_CFLAGS=' '
279 DBUS_LIBS=' '
280
281 --disable-acl
282 --disable-audit
283 --disable-gcrypt
284 --disable-gnutls
285 --disable-gtk-doc
286 --disable-introspection
287 --disable-kmod
288 --disable-libcryptsetup
289 --disable-microhttpd
290 --disable-networkd
291 --disable-pam
292 --disable-polkit
293 --disable-qrencode
294 --disable-seccomp
295 --disable-selinux
296 --disable-tests
297 --disable-xattr
298 --disable-xz
299 --disable-python-devel
300 )
301 fi
302
303 # Work around bug 463846.
304 tc-export CC
305
306 autotools-utils_src_configure
307 }
308
309 multilib_src_compile() {
310 local mymakeopts=(
311 udevlibexecdir="${MY_UDEVDIR}"
312 )
313
314 if multilib_is_native_abi; then
315 emake "${mymakeopts[@]}"
316 else
317 # prerequisites for gudev
318 use gudev && emake src/gudev/gudev{enumtypes,marshal}.{c,h}
319
320 echo 'gentoo: $(BUILT_SOURCES)' | \
321 emake "${mymakeopts[@]}" -f Makefile -f - gentoo
322 echo 'gentoo: $(lib_LTLIBRARIES) $(pkgconfiglib_DATA)' | \
323 emake "${mymakeopts[@]}" -f Makefile -f - gentoo
324 fi
325 }
326
327 multilib_src_test() {
328 multilib_is_native_abi || continue
329
330 default
331 }
332
333 multilib_src_install() {
334 local mymakeopts=(
335 # automake fails with parallel libtool relinking
336 # https://bugs.gentoo.org/show_bug.cgi?id=491398
337 -j1
338
339 udevlibexecdir="${MY_UDEVDIR}"
340 dist_udevhwdb_DATA=
341 DESTDIR="${D}"
342 )
343
344 if multilib_is_native_abi; then
345 emake "${mymakeopts[@]}" install
346 # Even with --enable-networkd, it's not right to have this running by default
347 # when it's unconfigured.
348 rm -f "${D}"/etc/systemd/system/multi-user.target.wants/systemd-networkd.service
349 else
350 mymakeopts+=(
351 install-libLTLIBRARIES
352 install-pkgconfiglibDATA
353 install-includeHEADERS
354 # safe to call unconditionally, 'installs' empty list
355 install-libgudev_includeHEADERS
356 install-pkgincludeHEADERS
357 )
358
359 emake "${mymakeopts[@]}"
360 fi
361
362 # install compat pkg-config files
363 local pcfiles=( src/compat-libs/libsystemd-{daemon,id128,journal,login}.pc )
364 emake "${mymakeopts[@]}" install-pkgconfiglibDATA \
365 pkgconfiglib_DATA="${pcfiles[*]}"
366
367 # Create symlinks for old libs
368 dosym libsystemd.so "/usr/$(get_libdir)/libsystemd-daemon.so"
369 dosym libsystemd.so "/usr/$(get_libdir)/libsystemd-id128.so"
370 dosym libsystemd.so "/usr/$(get_libdir)/libsystemd-journal.so"
371 dosym libsystemd.so "/usr/$(get_libdir)/libsystemd-login.so"
372 }
373
374 multilib_src_install_all() {
375 prune_libtool_files --modules
376 einstalldocs
377
378 # we just keep sysvinit tools, so no need for the mans
379 rm "${D}"/usr/share/man/man8/{halt,poweroff,reboot,runlevel,shutdown,telinit}.8 \
380 || die
381 rm "${D}"/usr/share/man/man1/init.1 || die
382
383 # Disable storing coredumps in journald, bug #433457
384 mv "${D}"/usr/lib/sysctl.d/50-coredump.conf{,.disabled} || die
385
386 # Preserve empty dirs in /etc & /var, bug #437008
387 keepdir /etc/binfmt.d /etc/modules-load.d /etc/tmpfiles.d \
388 /etc/systemd/ntp-units.d /etc/systemd/user /var/lib/systemd
389
390 # Symlink /etc/sysctl.conf for easy migration.
391 dosym ../sysctl.conf /etc/sysctl.d/99-sysctl.conf
392 }
393
394 migrate_locale() {
395 local envd_locale_def="${EROOT%/}/etc/env.d/02locale"
396 local envd_locale=( "${EROOT%/}"/etc/env.d/??locale )
397 local locale_conf="${EROOT%/}/etc/locale.conf"
398
399 if [[ ! -L ${locale_conf} && ! -e ${locale_conf} ]]; then
400 # If locale.conf does not exist...
401 if [[ -e ${envd_locale} ]]; then
402 # ...either copy env.d/??locale if there's one
403 ebegin "Moving ${envd_locale} to ${locale_conf}"
404 mv "${envd_locale}" "${locale_conf}"
405 eend ${?} || FAIL=1
406 else
407 # ...or create a dummy default
408 ebegin "Creating ${locale_conf}"
409 cat > "${locale_conf}" <<-EOF
410 # This file has been created by the sys-apps/systemd ebuild.
411 # See locale.conf(5) and localectl(1).
412
413 # LANG=${LANG}
414 EOF
415 eend ${?} || FAIL=1
416 fi
417 fi
418
419 if [[ ! -L ${envd_locale} ]]; then
420 # now, if env.d/??locale is not a symlink (to locale.conf)...
421 if [[ -e ${envd_locale} ]]; then
422 # ...warn the user that he has duplicate locale settings
423 ewarn
424 ewarn "To ensure consistent behavior, you should replace ${envd_locale}"
425 ewarn "with a symlink to ${locale_conf}. Please migrate your settings"
426 ewarn "and create the symlink with the following command:"
427 ewarn "ln -s -n -f ../locale.conf ${envd_locale}"
428 ewarn
429 else
430 # ...or just create the symlink if there's nothing here
431 ebegin "Creating ${envd_locale_def} -> ../locale.conf symlink"
432 ln -n -s ../locale.conf "${envd_locale_def}"
433 eend ${?} || FAIL=1
434 fi
435 fi
436 }
437
438 migrate_net_name_slot() {
439 # If user has disabled 80-net-name-slot.rules using a empty file or a symlink to /dev/null,
440 # do the same for 80-net-setup-link.rules to keep the old behavior
441 local net_move=no
442 local net_name_slot_sym=no
443 local net_rules_path="${EROOT%/}"/etc/udev/rules.d
444 local net_name_slot="${net_rules_path}"/80-net-name-slot.rules
445 local net_setup_link="${net_rules_path}"/80-net-setup-link.rules
446 if [[ -e ${net_setup_link} ]]; then
447 net_move=no
448 elif [[ -f ${net_name_slot} && $(sed -e "/^#/d" -e "/^\W*$/d" ${net_name_slot} | wc -l) == 0 ]]; then
449 net_move=yes
450 elif [[ -L ${net_name_slot} && $(readlink ${net_name_slot}) == /dev/null ]]; then
451 net_move=yes
452 net_name_slot_sym=yes
453 fi
454 if [[ ${net_move} == yes ]]; then
455 ebegin "Copying ${net_name_slot} to ${net_setup_link}"
456
457 if [[ ${net_name_slot_sym} == yes ]]; then
458 ln -nfs /dev/null "${net_setup_link}"
459 else
460 cp "${net_name_slot}" "${net_setup_link}"
461 fi
462 eend $? || FAIL=1
463 fi
464 }
465
466 pkg_postinst() {
467 enewgroup systemd-journal
468 if use http; then
469 enewgroup systemd-journal-gateway
470 enewuser systemd-journal-gateway -1 -1 -1 systemd-journal-gateway
471 fi
472 systemd_update_catalog
473
474 # Keep this here in case the database format changes so it gets updated
475 # when required. Despite that this file is owned by sys-apps/hwids.
476 if has_version "sys-apps/hwids[udev]"; then
477 udevadm hwdb --update --root="${ROOT%/}"
478 fi
479
480 udev_reload || FAIL=1
481
482 # Bug 468876
483 fcaps cap_dac_override,cap_sys_ptrace=ep usr/bin/systemd-detect-virt
484
485 # Bug 465468, make sure locales are respect, and ensure consistency
486 # between OpenRC & systemd
487 migrate_locale
488
489 # Migrate 80-net-name-slot.rules -> 80-net-setup-link.rules
490 migrate_net_name_slot
491
492 if [[ ${FAIL} ]]; then
493 eerror "One of the postinst commands failed. Please check the postinst output"
494 eerror "for errors. You may need to clean up your system and/or try installing"
495 eerror "systemd again."
496 eerror
497 fi
498
499 if [[ ! -L "${ROOT}"/etc/mtab ]]; then
500 ewarn "Upstream mandates the /etc/mtab file should be a symlink to /proc/mounts."
501 ewarn "Not having it is not supported by upstream and will cause tools like 'df'"
502 ewarn "and 'mount' to not work properly. Please run:"
503 ewarn " # ln -sf '${ROOT}proc/self/mounts' '${ROOT}etc/mtab'"
504 ewarn
505 fi
506
507 if ! has_version sys-apps/systemd-ui; then
508 elog "To get additional features, a number of optional runtime dependencies may"
509 elog "be installed:"
510 elog "- sys-apps/systemd-ui: for GTK+ systemadm UI and gnome-ask-password-agent"
511 fi
512 }
513
514 pkg_prerm() {
515 # If removing systemd completely, remove the catalog database.
516 if [[ ! ${REPLACED_BY_VERSION} ]]; then
517 rm -f -v "${EROOT}"/var/lib/systemd/catalog/database
518 fi
519 }